module.exports.drag = function (target, { start, move, end, setCursor }) {
	const originalPosition = Array(2)
	const deltaPosition = Array(2)

	let startValue
	function handlePointerstart(event) {
		window.addEventListener('mousemove', handlePointermove)
		window.addEventListener('mouseup', handlePointerend)
		originalPosition[0] = event.clientX
		originalPosition[1] = event.clientY
		if (setCursor) {
			document.documentElement.style.cursor = 'grabbing'
		}
		if (start) {
			startValue = start(event, originalPosition, null, null)
		}
	}

	let moveValue
	function handlePointermove(event) {
		deltaPosition[0] = event.clientX - originalPosition[0]
		deltaPosition[1] = event.clientY - originalPosition[1]
		if (move) {
			moveValue = move(event, originalPosition, deltaPosition, startValue)
		}
	}

	function handlePointerend(event) {
		window.removeEventListener('mousemove', handlePointermove)
		window.removeEventListener('mouseup', handlePointerend)
		if (setCursor) {
			document.documentElement.style.cursor = ''
		}
		if (end) {
			end(event, originalPosition, deltaPosition, moveValue)
		}
	}

	target.addEventListener('mousedown', handlePointerstart)
}